import os.path
import subprocess
import sys


class libNom(object):
    def __init__(self):
        self._lib_path = os.path.join(os.path.dirname(__file__),
                'nom.py')
    def nom_success(self):
        self._run_command('success')

    def nom_fail(self):
        self._run_command('fail')

    def nom_echo(self, arg):
        self._run_command('echo', arg)

    def nom_rand(self, arg):
        self._run_command('rand', arg)

    def nom_nslookup(self, arg):
        self._run_command('nslookup', arg)

    def nom_ping(self, arg):
        self._run_command('ping', arg)

    def nom_speedtest(self, arg):
        self._run_command('speedtest', arg)

    def result_is(self, expected_result):
        if expected_result == "any" and str(self._result) != "False":
            print(f"any: {self._result}")
            return
        if expected_result != self._result:
            raise AssertionError("Expected result: '%s' but result: '%s'."
                                 % (expected_result, self._result))

    def result_leq(self, expected_result):
        if not float(self._result) <=  float(expected_result):
            raise AssertionError("Expected result leq '%s' but result '%s'."
                                 % (expected_result, self._result))


    def result_geq(self, expected_result):
        if not float(self._result) >= float(expected_result):
            raise AssertionError("Expected result geq '%s' but result '%s'."
                                 % (expected_result, self._result))

    def _run_command(self, command, *args):
        command = [sys.executable, self._lib_path, command] + list(args)
        process = subprocess.Popen(command,
                universal_newlines=True, stdout=subprocess.PIPE,
                stderr=subprocess.STDOUT)
        self._result = process.communicate()[0].strip()
