#!/usr/bin/env python
import os.path
import sys
import random
import dns.resolver
from ping3 import ping
import speedtest


class Nom(object):
    def __init__(self):
        pass

    def __enter__(self):
        return self

    def __exit__(self, *exc_info):
        pass

    def help(self):
        file = os.path.basename(sys.argv[0])
        print(f"Usage: {file} [success | fail | echo <arg> | rand <arg> | nslookup <host> | ping \
                <host> | speedtest <up|down> | help]")

    def success(self):
        ret = True
        return ret

    def fail(self):
        ret = False
        return ret

    def rand(self, arg):
        ret = random.randint(0, int(arg))
        return ret

    def echo(self, arg):
        return arg

    def nslookup(self, arg):
        ret = False
        try:
            res = dns.resolver.resolve(arg, "A")
            ret = ",".join(str(r) for r in res)
        except:
            pass

        # print(f"nslookup {arg}: {ret}")
        return ret

    def ping(self, arg):
        ret = False
        try:
            ret = ping(arg, unit='ms')
        except Exception as ex:
            print(f"Exception Type:{type(ex).__name__}, args:{ex.args}")

        # print(f"ping {arg}: {ret}")
        return ret

    def speedtest(self, arg):
        ret = 0.0
        s = speedtest.Speedtest()
        s.get_best_server()
        threads = None
        if arg == "up":
            res = s.upload(threads=threads)
        elif arg == "down":
            res = s.download(threads=threads)

        ret = float(res)/1E6
        # print(f"speedtest {arg}: {ret}")
        return ret


def main():
    try:
        action = sys.argv[1]
    except IndexError:
        action = "help"
    args = sys.argv[2:]

    with Nom() as N:
        try:
          f = getattr(N, action)
          print(f(*args))
        except Exception as ex:
            print(f"Exception Type:{type(ex).__name__}, args:{ex.args}")
            N.help()


if __name__ == "__main__":
    main()
